"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var epub_1 = __importDefault(require("epub"));
var epub_gen_1 = __importDefault(require("epub-gen"));
function readEpub(path) {
    return __awaiter(this, void 0, void 0, function () {
        var epub;
        var _this = this;
        return __generator(this, function (_a) {
            epub = new epub_1.default(path);
            return [2 /*return*/, new Promise(function (resolve) {
                    epub.on("end", function () { return __awaiter(_this, void 0, void 0, function () {
                        var metadata, chapters;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    // epub is now usable
                                    console.log("Converting the book - " + epub.metadata.title);
                                    metadata = epub.metadata;
                                    return [4 /*yield*/, readChapters(epub)];
                                case 1:
                                    chapters = _a.sent();
                                    resolve({ metadata: metadata, chapters: chapters });
                                    return [2 /*return*/];
                            }
                        });
                    }); });
                    epub.parse();
                })];
        });
    });
}
exports.readEpub = readEpub;
function createEpub(options, output) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new epub_gen_1.default(options, output).promise.then(function () {
                    console.log("Ebook Generated Successfully at path: " + output + "!");
                }, function (err) {
                    console.error("Failed to generate Ebook because of ", err);
                })];
        });
    });
}
exports.createEpub = createEpub;
function asLoggingInfo(chapter) {
    var isMetaChapter = !('title' in chapter && 'order' in chapter);
    if (isMetaChapter) {
        return "Now at meta chapter - id: " + chapter.id + " / href: " + chapter.href + " ";
    }
    else {
        return "Now at chapter " + chapter.order + " - title: " + chapter.title;
    }
}
function readChapters(epub) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2 /*return*/, epub.flow.reduce(function (prevPromise, chapter) { return __awaiter(_this, void 0, void 0, function () {
                    var chapters, text;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                console.log(asLoggingInfo(chapter));
                                return [4 /*yield*/, prevPromise];
                            case 1:
                                chapters = _a.sent();
                                return [4 /*yield*/, readChapter(epub, chapter.id)];
                            case 2:
                                text = _a.sent();
                                chapters[chapter.id] = Object.assign({ text: text }, chapter);
                                return [2 /*return*/, chapters];
                        }
                    });
                }); }, Promise.resolve({}))];
        });
    });
}
function readChapter(epub, id) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    return epub.getChapter(id, function (err, text) {
                        return err ? reject(err) : resolve(text);
                    });
                })];
        });
    });
}
